<CsoundSynthesizer>
; clockon/clockoff/readclock example - written by Istvan Varga, 2003
; measures the approximate time it takes to execute any Csound
; orchestra code (perf time only), and calculates the maximum possible
; overlaps in real-time
<CsOptions>
; run in real-time (there is no audio output, though)
-d -m0 -H0 -s -h -o dac
</CsOptions>
<CsInstruments>
sr      =  44100
ksmps   =  30
nchnls  =  1

        instr 1

        clockon 1
; ---- put here any code to be timed ----
a1      vco2 1000, 440
; ---- end of test code ----
        clockoff 1
; dummy clockon/clockoff pair to measure the CPU usage of the
; timer itself
        clockon 2
        clockoff 2
; read the time values. readclock works at k-rate if it has a k-rate
; output variable. imode=1 (real time) is used, because it has higher
; time resolution (better than 1 us under Win32, and 1 CPU cycle
; under Linux/x86) than imode=0 (CPU time, usually ~1 ms resolution),
; although other programs running in multi-tasking may result in
; incorrect times being measured.
ktime   readclock 1, 1
ktime2  readclock 2, 1
; subtract the time elapsed by the dummy clockon/clockoff pair for
; more a accurate result
        vdecr ktime, ktime2
; attempt to filter out anomalous values
ktime2  limit ktime2, 0.000001, 1.0             ; 1 ns to 1 ms
; apply smoothing for stable output; however, it takes longer time
; (~10-20 seconds) to reach the final value
ktime2  port ktime, 1.0, 0.1
; estimate the maximum possible overlaps in real-time by dividing the
; time of a k-cycle with the measured time
kovrlp  =  (1000 / kr) / ktime2
; convert milliseconds to microseconds
        vmul ktime2, 1000
; print the results
        printks "time (us) = %f, max overlaps = %f\\n", 0.5, ktime2, kovrlp

        endin

</CsInstruments>
<CsScore>
i 1 0 3600
e

</CsScore>
</CsoundSynthesizer>

