
/* globals.c -- written by Istvan Varga, 2003 */

#include <cs.h>
#include "oload.h"

/* IV - Jan 30 2003: to have access to the real exit() function */
#ifdef exit
#undef exit
#endif

/* global variables sr, kr, ksmps, and nchnls,         */
/* and some commonly used values calculated from these */

int             CSGLOBAL(ksmps),    CSGLOBAL(global_ksmps);
MYFLT           CSGLOBAL(ensmps),   CSGLOBAL(global_ensmps);
MYFLT           CSGLOBAL(ekr),      CSGLOBAL(global_ekr);
/* 1 / kr */
MYFLT           CSGLOBAL(onedkr),   CSGLOBAL(global_onedkr);
/* 0.5 / kr */
MYFLT           CSGLOBAL(hfkprd),   CSGLOBAL(global_hfkprd);
/* FMAXLEN / kr */
MYFLT           CSGLOBAL(kicvt),    CSGLOBAL(global_kicvt);
/* number of k-periods since beginning of performance */
long            CSGLOBAL(kcounter), CSGLOBAL(global_kcounter);
MYFLT           CSGLOBAL(esr);
/* 1 / sr */
MYFLT           CSGLOBAL(onedsr);
/* FMAXLEN / sr */
MYFLT           CSGLOBAL(sicvt);
int             CSGLOBAL(nchnls);
/* orchestra header variables calculated by otran */
MYFLT           CSGLOBAL(tran_sr), CSGLOBAL(tran_kr);
MYFLT           CSGLOBAL(tran_ksmps);
MYFLT           CSGLOBAL(tran_0dbfs);
int             CSGLOBAL(tran_nchnls);
/* (2PI / sr), (-PI / sr), and (-2PI / sr) */
MYFLT           CSGLOBAL(tpidsr), CSGLOBAL(mpidsr), CSGLOBAL(mtpdsr);

/* orchestra / score names */

char            * CSGLOBAL(orchname), * CSGLOBAL(scorename);
char            * CSGLOBAL(xfilename);

/* float I/O buffers (ksmps samples) */

MYFLT           * CSGLOBAL(spin);
MYFLT           * CSGLOBAL(spout);
int             CSGLOBAL(nspin);
int             CSGLOBAL(nspout);
int             CSGLOBAL(spoutactive);

/* ZAK system */

MYFLT           * CSGLOBAL(zastart);
long            CSGLOBAL(zalast);
MYFLT           * CSGLOBAL(zkstart);
long            CSGLOBAL(zklast);

/* opcode list, user defined opcodes, and named instruments */

OENTRY          * CSGLOBAL(opcodlst);
void            * CSGLOBAL(opcode_list);        /* IV - Oct 31 2002 */
OENTRY          * CSGLOBAL(oplstend);
OPCODINFO       * CSGLOBAL(opcodeInfo);         /* IV - Oct 20 2002 */
void            * CSGLOBAL(instrumentNames);

/* 0dBFS system */

MYFLT           CSGLOBAL(e0dbfs);
MYFLT           CSGLOBAL(dbfs_to_short);
MYFLT           CSGLOBAL(short_to_dbfs);
MYFLT           CSGLOBAL(dbfs_to_float);
MYFLT           CSGLOBAL(float_to_dbfs);
MYFLT           CSGLOBAL(dbfs_to_long);
MYFLT           CSGLOBAL(long_to_dbfs);

/* real-time audio device numbers for Win32 */

unsigned int    CSGLOBAL(rtin_dev);
unsigned int    CSGLOBAL(rtout_dev);

/* for 'midiin' opcode */

int             CSGLOBAL(MIDIINbufIndex);
MIDIMESSAGE     CSGLOBAL(MIDIINbuffer2[MIDIINBUFMAX]);

/* peak amplitude and position, and out of range samples */

MYFLT           CSGLOBAL(maxamp[MAXCHNLS]);     /* note */
MYFLT           CSGLOBAL(smaxamp[MAXCHNLS]);    /* section */
MYFLT           CSGLOBAL(omaxamp[MAXCHNLS]);    /* overall */
MYFLT           * CSGLOBAL(maxampend);
unsigned long   CSGLOBAL(maxpos[MAXCHNLS]);
unsigned long   CSGLOBAL(smaxpos[MAXCHNLS]);
unsigned long   CSGLOBAL(omaxpos[MAXCHNLS]);
long            CSGLOBAL(rngcnt[MAXCHNLS]);
short           CSGLOBAL(rngflg);

short           CSGLOBAL(multichan);    /* non-zero if nchnls > 1 */

/* oload.h (???) */
short           CSGLOBAL(nlabels);
short           CSGLOBAL(ngotos);
int             CSGLOBAL(strsmax);
char            ** CSGLOBAL(strsets);
int             CSGLOBAL(peakchunks);

/* misc. global variables (FIXME: to be documented ... ) */

EVTBLK          * CSGLOBAL(currevent);
int             CSGLOBAL(keep_tmp);
int             CSGLOBAL(dither_output);
FILE            * CSGLOBAL(dribble);            /* log file */
long            CSGLOBAL(holdrand);
int             CSGLOBAL(maxinsno);
int             CSGLOBAL(maxopcno);             /* IV - Oct 24 2002 */
INSDS           * CSGLOBAL(curip);
EVTBLK          * CSGLOBAL(Linevtblk);
long            CSGLOBAL(nrecs);
FILE            * CSGLOBAL(Linepipe);
int             CSGLOBAL(Linefd);
MYFLT           * CSGLOBAL(ls_table);
MYFLT           CSGLOBAL(curr_func_sr);
char            * CSGLOBAL(retfilnam);
INSTRTXT        ** CSGLOBAL(instrtxtp);
/* sprintf space for compiling msgs */
char            CSGLOBAL(errmsg[ERRSIZ]);
FILE            * CSGLOBAL(scfp);
FILE            * CSGLOBAL(oscfp);
int             CSGLOBAL(tieflag);
char            * CSGLOBAL(ssdirpath), * CSGLOBAL(sfdirpath);
char            * CSGLOBAL(tokenstring);
POLISH          * CSGLOBAL(polish);
FILE            * CSGLOBAL(scorein);
FILE            * CSGLOBAL(scoreout);
MYFLT           * CSGLOBAL(pool);
short           * CSGLOBAL(argoffspace);
INSDS           * CSGLOBAL(frstoff);
int             CSGLOBAL(sensType);
SRTBLK          * CSGLOBAL(frstbp);
int             CSGLOBAL(sectcnt);
MCHNBLK         * CSGLOBAL(m_chnbp[MAXCHAN]);
MYFLT           * CSGLOBAL(cpsocint), * CSGLOBAL(cpsocfrc);
int             CSGLOBAL(inerrcnt);         /* init error count */
int             CSGLOBAL(synterrcnt);       /* syntax error count */
int             CSGLOBAL(perferrcnt);       /* perf error count */
int             CSGLOBAL(MIDIoutDONE);
int             CSGLOBAL(midi_out);
char            CSGLOBAL(strmsg[100]);
INSTRTXT        CSGLOBAL(instxtanchor);
INSDS           CSGLOBAL(actanchor);
/* List of started events, used in playevents() */
EVTNODE         CSGLOBAL(OrcTrigEvts);
char            CSGLOBAL(name_full[256]);   /* Remember name used */
int             CSGLOBAL(Mforcdecs), CSGLOBAL(Mxtroffs);
int             CSGLOBAL(MTrkend);
char            * CSGLOBAL(sadirpath);
char            * CSGLOBAL(oplibs);
OPARMS          * CSGLOBAL(oparms);
jmp_buf         CSGLOBAL(exitjmp);

/* default OPARMS structure */

static OPARMS  O_ = {           /* IV - Nov 10 2002 */
        0, 0,                   /* odebug, initonly                         */
        0, 1, 1, 0,             /* sfread, sfwrite, sfheader, filetyp       */
        0, 0,                   /* inbufsamps, outbufsamps                  */
#if defined(LINUX) && defined(HAVE_ALSA)        /* IV - Nov 10 2002 */
        NULL, NULL,             /* pcm_input_device, pcm_output_device      */
#endif
        0, 0,                   /* informat, outformat                      */
        0, 0,                   /* insampsiz, outsampsiz                    */
        1, 0, 0, 7,             /* displays, graphsoff, postscript, msglevel*/
        0, 0, 0,                /* Beatmode, cmdTempo, oMaxLag              */
        NULL, NULL,             /* outorchnam, outsconam                    */
        0,                      /* IV - Jan 08 2003: expr_opt               */
        0, 0, 0, 0,             /* usingcscore, Linein, Midiin, FMidiin     */
        0, 0                    /* OrcEvts, RTevents                        */
};

OPARMS  CSGLOBAL(O);

static  int     globals_are_set = 0;

/* reset all global variables, and install default CsoundAPI callback */
/* functions on first call */

void globalsRESET(void)
{
    /* global variables sr, kr, ksmps, and nchnls,         */
    /* and some commonly used values calculated from these */

    ksmps     = global_ksmps      = DFLT_KSMPS;
    ensmps    = global_ensmps     = (MYFLT) ksmps;
    ekr       = global_ekr        = DFLT_KR;
    /* 1 / kr */
    onedkr    = global_onedkr     = (FL(1.0) / ekr);
    /* 0.5 / kr */
    hfkprd    = global_hfkprd     = (FL(0.5) / ekr);
    /* FMAXLEN / kr */
    kicvt     = global_kicvt      = ((MYFLT) FMAXLEN / ekr);
    /* number of k-periods since beginning of performance */
    kcounter  = global_kcounter   = 0L;
    esr       = DFLT_SR;
    /* 1 / sr */
    onedsr    = (FL(1.0) / esr);
    /* FMAXLEN / sr */
    sicvt     = ((MYFLT) FMAXLEN / esr);
    nchnls    = DFLT_NCHNLS;
    /* orchestra header variables calculated by otran */
    tran_sr       = tran_kr       = tran_ksmps    = FL(-1.0);
    tran_0dbfs    = DFLT_DBFS;
    tran_nchnls   = DFLT_NCHNLS;
    /* (2PI / sr), (-PI / sr), and (-2PI / sr) */
    tpidsr = TWOPI_F / esr;
    mpidsr = -(PI_F / esr);
    mtpdsr = -tpidsr;

    /* orchestra / score names */

    orchname  = scorename     = NULL;
    xfilename = NULL;

    /* float I/O buffers (ksmps samples) */

    spin      = NULL;
    spout     = NULL;
    nspin     = 0;
    nspout    = 0;
    spoutactive   = 0;

    /* ZAK system */

    zastart   = NULL;
    zalast    = 0L;
    zkstart   = NULL;
    zklast    = 0L;

    /* opcode list, user defined opcodes, and named instruments */

    opcodlst          = NULL;
    opcode_list       = NULL;   /* IV - Oct 31 2002 */
    oplstend          = NULL;
    opcodeInfo        = NULL;   /* IV - Oct 20 2002 */
    instrumentNames   = NULL;

    /* 0dBFS system */

    e0dbfs            = DFLT_DBFS;
    dbfs_to_short     = FL(32767.0) / e0dbfs;
    short_to_dbfs     = e0dbfs / FL(32767.0);
    dbfs_to_float     = FL(1.0) / e0dbfs;
    float_to_dbfs     = e0dbfs;
    dbfs_to_long      = FL(2147483647.0) / e0dbfs;
    long_to_dbfs      = e0dbfs / FL(2147483647.0);

    /* real-time audio device numbers for Win32 */

    rtin_dev      = 1024u;
    rtout_dev     = 1024u;

    /* for 'midiin' opcode */

    MIDIINbufIndex    = 0;
    memset(MIDIINbuffer2, 0, sizeof(MIDIMESSAGE) * MIDIINBUFMAX);

    /* peak amplitude and position, and out of range samples */

    memset(maxamp, 0, sizeof(MYFLT) * MAXCHNLS);        /* note */
    memset(smaxamp, 0, sizeof(MYFLT) * MAXCHNLS);       /* section */
    memset(omaxamp, 0, sizeof(MYFLT) * MAXCHNLS);       /* overall */
    maxampend = NULL;
    memset(maxpos, 0, sizeof(unsigned long) * MAXCHNLS);
    memset(smaxpos, 0, sizeof(unsigned long) * MAXCHNLS);
    memset(omaxpos, 0, sizeof(unsigned long) * MAXCHNLS);
    memset(rngcnt, 0, sizeof(long) * MAXCHNLS);
    rngflg    = 0;

    multichan = (nchnls > 1 ? 1 : 0);   /* non-zero if nchnls > 1 */

    /* oload.h (???) */
    nlabels       = NLABELS;
    ngotos        = NGOTOS;
    strsmax       = 0;
    strsets       = NULL;
    peakchunks    = 1;

    /* misc. global variables (FIXME: to be documented ... ) */

    currevent     = NULL;
    keep_tmp      = 0;
    dither_output = 0;
    dribble       = NULL;               /* log file */
    holdrand      = 2345678L;
    maxinsno      = MAXINSNO;
    maxopcno      = -1;                 /* IV - Oct 24 2002 */
    curip         = NULL;
    Linevtblk     = NULL;
    nrecs         = 0L;
    Linepipe      = NULL;
    Linefd        = -1;
    ls_table      = NULL;
    curr_func_sr  = FL(0.0);
    retfilnam     = NULL;
    instrtxtp     = NULL;
    /* sprintf space for compiling msgs */
    memset(errmsg, 0, sizeof(char) * ERRSIZ);
    scfp          = NULL;
    oscfp         = NULL;
    tieflag       = 0;
    ssdirpath     = sfdirpath     = NULL;
    tokenstring   = NULL;
    polish        = NULL;
    SCOREIN       = NULL;
    SCOREOUT      = NULL;
    pool          = NULL;
    ARGOFFSPACE   = NULL;
    frstoff       = NULL;
    sensType      = 0;
    frstbp        = NULL;
    sectcnt       = 0;
    memset(M_CHNBP, 0, sizeof(MCHNBLK*) * MAXCHAN);
    cpsocint      = cpsocfrc      = NULL;
    inerrcnt      = 0;                  /* init error count */
    synterrcnt    = 0;                  /* syntax error count */
    perferrcnt    = 0;                  /* perf error count */
    MIDIoutDONE   = 0;
    midi_out      = -1;
    memset(strmsg, 0, sizeof(char) * 100);
    memset(&instxtanchor, 0, sizeof(INSTRTXT));
    memset(&actanchor, 0, sizeof(INSDS));
    /* List of started events, used in playevents() */
    memset(&OrcTrigEvts, 0, sizeof(EVTNODE));
    memset(name_full, 0, sizeof(char) * 256);   /* Remember name used */
    Mforcdecs     = Mxtroffs      = 0;
    MTrkend       = 0;
    sadirpath     = NULL;
    CSGLOBAL(oplibs)  = NULL;
    CSGLOBAL(oparms)  = &(CSGLOBAL(O));

    globals_are_set = 1;        /* mark as initialised */
    {
      int   i;
      /* set up a default exitjmp handler */
      /* user code can override it for re-entrancy */
      if ((i = setjmp(exitjmp)) != 0) {
        if (i == CSOUND_EXITJMP_NOERROR)
          exit(0);
        else
          exit(i);
      }
    }
    memset(&(CSGLOBAL(O)), 0, sizeof(OPARMS));
    CSGLOBAL(O) = O_;
    CSGLOBAL(oparms) = &(CSGLOBAL(O));
}

/* same as globalsRESET(), but has no effect */
/* if globals are already initialised */

void globals_init(void)
{
    if (!globals_are_set) {
      globalsRESET();
    }
}

