
#ifndef CSOUND_TIMERS_H
#define CSOUND_TIMERS_H

/* timers.h -- written by Istvan Varga, 2003 */

#ifdef __cplusplus
extern "C" {
#endif

typedef struct RTCLOCK_S {
    unsigned long   starttime_real_high;
    unsigned long   starttime_real_low;
    double          real_time_to_seconds_scale;
    unsigned long   starttime_CPU_high;
    unsigned long   starttime_CPU_low;
    double          CPU_time_to_seconds_scale;
} RTCLOCK;

/* initialise a timer structure */

void timers_struct_init(RTCLOCK*);

/* return the elapsed real time (in seconds) since the specified timer */
/* structure was initialised */

double timers_get_real_time(RTCLOCK*);

/* return the elapsed CPU time (in seconds) since the specified timer */
/* structure was initialised */

double timers_get_CPU_time(RTCLOCK*);

/* return a 32-bit unsigned integer to be used as seed from current time */

unsigned long timers_random_seed(void);

#ifdef __cplusplus
}
#endif

#endif          /* CSOUND_TIMERS_H */

