                                                /*  USTUB.H  */
#ifndef CSOUND_USTUB_H
#define CSOUND_USTUB_H

/* header and dummy global references for main.c stub in  */
/* standalone versions of hetro, lpanal, pvanal, sndinfo  */

void    fdrecord(FDCH *fdchp)       {   IGN(fdchp);         }
void    initerror(char *s)          {   IGN(s);             }
void    perferror(char *s)          {   IGN(s);             }
void    sndwrterr(int n, int nput)  {   IGN(n); IGN(nput);  }

int  Graphable_(void);          /* initialise windows.  Returns 1 if X ok */
void MakeGraph_(WINDAT *, char *);      /* create wdw for a graph */
void MakeXYin_(XYINDAT *, MYFLT, MYFLT);
                                /* create a mouse input window; init scale */
void DrawGraph_(WINDAT *);      /* update graph in existing window */
void ReadXYin_(XYINDAT *);      /* fetch latest value from ms input wdw */
void KillGraph_(WINDAT *);      /* remove a graph window */
void KillXYin_(XYINDAT *);      /* remove a ms input window */
int  ExitGraph_(void);          /* print click-Exit message in */
                                /* most recently active window */

/* IV - Jan 30 2003 */

void init_getstring(int, char**);

#define UTIL_MAIN_INIT                                                 \
{                                                                      \
    globals_init();                                                    \
    init_getstring(argc, argv);                                        \
}

#ifdef exit
#undef exit
#endif

void err_printf(const char *format, ...)
{
    va_list args;
    va_start(args, format);
    vfprintf(stderr, format, args);
    va_end(args);
    if (dribble != NULL) {
      va_start(args, format);
      vfprintf(dribble, format, args);
      va_end(args);
    }
}

void dribble_printf(const char *format, ...)
{
    va_list args;
    if (dribble != NULL) {
      va_start(args, format);
      vfprintf(dribble, format, args);
      va_end(args);
    }
    va_start(args, format);
    vfprintf(stdout, format, args);
    va_end(args);
}

#endif          /* CSOUND_USTUB_H */

